package biblioteca;

public class SearchKey
{
	String nome;
	String cognome;

	public SearchKey(String a)
	{
		a = a.trim();
		int fine = a.lastIndexOf((int)' ');
		if(fine == -1)//e' una parola sola
		{
			cognome = a;
			nome = "";
		}
		else
		{
			nome = a.substring(0, fine).trim();
			cognome = a.substring(fine, a.length()).trim();
		}
	}

	public int hashCode()
	{
		return (cognome + " " + nome).hashCode();
	}

	public boolean equals(Object o)
	{
		SearchKey s = (SearchKey)o;
		return cognome.equals(s.cognome) && nome.equals(s.nome);
	}

	public String toString()
	{
		return cognome + " " + nome;
	}
}
