package linkate;
public class NodoDoppio<E>
{
	E value;

	//public static List lista;

	NodoDoppio<E> prev, next;

	public NodoDoppio(E elem)
	{
		value = elem;
		prev = next = null;

		//lista.add(this);
	}

	public NodoDoppio<E> getNext()
	{
		return next;
	}

	public NodoDoppio<E> setNext(NodoDoppio<E> theNext)
	{
		NodoDoppio<E> retval = next;
		next = theNext;
		return retval;
	}

	public NodoDoppio<E> getPrev()
	{
		return prev;
	}

	public NodoDoppio<E> setPrev(NodoDoppio<E> thePrev)
	{
		NodoDoppio<E> retval = prev;
		prev = thePrev;
		return retval;
	}

	public E getValue()
	{
		return value;
	}

	/**
	* Metodo di uguaglianza tra istanze di NodoDoppio.
	* Controlla l'uguaglianza del valore.
	* Precondizione: il parametro o deve essere di tipo NodoDoppio.
	*/
	public boolean equals(Object o)
	{
		// assertion non deve coesistere con un test di consistenza come quello sotto
		assert o instanceof NodoDoppio;

		//test attivato al rilascio, in test/debug voglio avere l'eccezione
		//non deve coesistere con le asserzioni delle precondizioni
		/*
		if(!(o instanceof NodoDoppio)
		{
			return false;
		}
		*/

		NodoDoppio tmp = (NodoDoppio)o;
		if(value == null)
		{
			return tmp.value == null;
		}
		return value.equals(tmp.value);
	}

	public String toString()
	{
		return String.valueOf(value);
	}

	/*
	static
	{
		lista = new LinkedList();
	}
	*/
}
