package biblioteca;

import java.io.*;
import java.util.*;

public class Libreria2
{
	//ArrayList<Autore> autori;
	Map<String, Autore> autori;

	public Libreria2()
	{
		//autori = new ArrayList<Autore>();
		autori = new HashMap<String, Autore>();
	}

	public void mainLoop()
	{
		Scanner scIn;

		scIn = new Scanner(System.in);

		while(true)
		{
			System.out.print("Comando ? > ");
			String line = scIn.nextLine();

			if(line.equals("") || line.equals("esci") || line.equals("basta"))
			{
				//esco
				break;
			}
			else if(line.equals("leggi"))
			{
				leggi(scIn);
			}
			else if(line.equals("autore"))
			{
				autore(scIn);
			}
			else if(line.equals("stampa"))
			{
				stampa(scIn);
			}
			else
			{
				System.out.println("Comando <" + line + "> non riconosciuto");
			}
		}
		scIn.close();
	}
	
	private void leggi(Scanner scIn)
	{
		//leggo da file
		Scanner scFile;

		System.out.print("Nome file ? > ");
		String nomeFile = scIn.nextLine();

		try
		{
			scFile = new Scanner(new File(nomeFile));
			//assumo che il file contenga sempre gruppi di tre
			//linee, niente records smozzicati.
			while(scFile.hasNextLine())
			{
				String tipo = scFile.nextLine();
				if(!tipo.equals("biblioteca.Libro"))
				{
					System.out.println("Media di tipo <" + tipo + "> non gestito");
					continue;
				}
				Libro nuovoLibro = new Libro(scFile.nextLine(), scFile.nextLine(), Integer.parseInt(scFile.nextLine()), scFile.nextLine());
				Autore autNuovo = null;
				autNuovo = autori.get(nuovoLibro.autore);
				if(autNuovo == null)//non ho ancora un riferimento a questo autore?
				{
					autNuovo = new Autore(nuovoLibro.autore);
					autori.put(nuovoLibro.autore, autNuovo);
				}
				autNuovo.add(nuovoLibro);
			}
			scFile.close();
		}
		catch(FileNotFoundException fnfe)
		{
			fnfe.printStackTrace();
		}
	}

	private void autore(Scanner scIn)
	{
		//stampo il singolo autore
		System.out.print("Autore ? > ");
		String autore = scIn.nextLine();

		Autore aut = autori.get(autore);
		if(aut == null)
		{
			System.out.println("Non ho riferimento all'autore " + autore);
			return;
		}
		System.out.println(aut);
	}

	private void stampa(Scanner scIn)
	{
		//stampo tutto
		System.out.println(autori);
	}

	public static void main(String[] argv)
	{
		(new Libreria2()).mainLoop();
	}
}
